/*
      "RICE BOWL WITH CHOPSTICKS"
   
   -- by Glenn Slingsby,  CIS 76660,354
      March 1993

      1 hr 53 mins. render time on 386/20MHz with math co-processor, with 
      these options: +w266 +h200 +a0.4 +mv1.0
                                       ^^^^^^
      Note this was created using ver 1.0 of POVRAY, so the above option 
      should be used if rendering using ver 2.0 of same.

      This file was created without the use of a modeller which I now consider
      a "must have" to do the initial slug work. It took me absolutely ages
      to get all the positioning right doing it the "manual" way, but I think
      the results were worth it.

      This file uses WICKER.GIF for the image_map.
*/

#include "colors.inc"
#include "shapes.inc"
#include "shapes2.inc"
#include "stones.inc"
#include "textures.inc"

camera {
  location <0 3 -11>   
  direction <0 0 1.303277>
  up <0 1 0>
  right <1.3333 0 0>
  look_at <0 0 -1.5> // 0 0 0
}

// *** Main light ***
object { light_source { <6 8 -30> color White } }     

// *** Front spotlight ***
// I like the filled in shadows the use of two lights creates here.
object {    
    light_source { <-3 10 -10> 
        color White 
        spotlight
        point_at <0 0 0>
        radius 35
        falloff 65
        tightness 50
     } 
}    

// *** Rear spotlight to help light up table at back ***
object {        
    light_source { <0 6 6> 
        color White 
        spotlight
        point_at <0 0 0>
        radius 55
        falloff 85
        tightness 70
     } 
}    

// *** Table top ***
object {   
   plane { <0 1 0> -3 }  
   texture {
      Tan_Wood
      scale <-0.5 -0.5 1>
      rotate <0 45 0> 
   }  
}

// *** "Wicker" table top divider ***    
object {   
     plane { <0 0 1> 5 }  
       texture {
          image_map { 0 gif "wicker.gif"  
            alpha 10 1    // these alpha colors make the areas
            alpha 11 1    // between the wicker clear. If you look
            alpha 12 1    // carefully you can actually see the table
            alpha 13 1    // on the other side.
            alpha 14 1
            alpha 15 1
            interpolate 2
          }
       diffuse 0.75
         scale <25 25 1>
         rotate <0 0 90>  
   }
}

// *** The Bowl ***
// I uploaded the finished GIF saying that the bowl was JADE but it would
// appear that I used a modified MARBLE (looks like Jade a bit, though).
object {  
  intersection {
     quadric { Ellipsoid scale <4.5 3 4.5> }
     plane { <0 1 0> 0.6 }
  }
             texture { 
               marble
               turbulence 2  
               colour_map {
                 [0 .6 color red .1 green .6 blue .1
                       color red 0  green .3 blue 0]
                 [.6 .8 color red .85 green .85 blue .1
                        color red .85 green .85 blue .1]  
                 [.8 1 color red .1 green .6 blue .1
                       color red 0 green .2 blue 0]
             } 
              scale <5 5 5> // the texture only
              rotate <10 10 10>  
           }
   clipped_by { quadric { Ellipsoid scale <4.3 2.8 4.3> inverse } }  
   bounded_by { sphere { <0 0 0> 4.8 } }
         translate <0 0 0>
}

// *** Fill bowl with rice ! ***
// This took forever to get the look right!  It still isn't as physically
// "lumpy" as I would like it, but it works okay.
object {   
     quadric { Ellipsoid 
         scale <4.29 0.5 4.29> 
     }
     texture {
       ambient 0.3
       bumps 1
       turbulence 8  
       leopard color_map {
          [0 .10 color red .99 green .99 blue .99
               color red .99 green .99 blue .99] 
          [.10 .90 color red 1 green 1 blue 1
               color red 1 green 1 blue 1] 
          [.90 1 color red .99 green .99 blue .99
               color red .99 green .99 blue .99] 
               
      }
          scale <0.6 0.6 0.6> 
          rotate <90 90 90> 
     }
}

// *** Chopstick #1 ***
// Again, these took a long time to position and texture...
object {  
      intersection { Pyramid }
       texture { 
         Yellow_Pine
        rotate <0 90 0> // texture only
       }
      scale <0.3 4.8 0.3>
      rotate <-45 50 110>   
      translate <2 -0.2 0>
    clipped_by { plane { <0 1 0> 0.02 inverse } }
}

// *** Chopstick #2 ***
object {  
      intersection { Pyramid }
       texture {
         Yellow_Pine
        rotate <0 90 0>  // texture only
       }
      scale <0.3 4.8 0.3>
      rotate <-50 45 80>
      translate <2 0 0> 
    clipped_by { plane { <0 1 0> 0.02 inverse } }
}
// END

